name: tlaternet
version: 1.0.0
description: tlaternet web interface
author: Tristan Maat <tm@tlater.net>
license: MIT
private: true

dependencies:
  # Libraries
  gl-matrix: ^3.4.4   # To help with 3D math in WebGL code
  classnames: ^2.5.1 # To manage CSS class names in react code

  # Fonts
  hack-font: ^3.3.0
  '@fontsource/arimo': ^5.2.8
  '@fontsource/nunito': ^5.2.7
  '@fortawesome/fontawesome-free': ^7.1.0

  # Frameworks for static content
  bulma: ^1.0.4

  # React-redux stuff
  react: ^19.2.0
  react-dom: ^19.2.0
  react-use-error-boundary: ^3.0.0 # TODO(tlater): Remove when react implement their own
  redux: ^5.0.1
  '@reduxjs/toolkit': ^2.10.1
  react-redux: ^9.2.0

devDependencies:
  # Parcel & plugins
  parcel: ^2.16.1
  '@parcel/transformer-sass': ^2.16.1
  '@parcel/transformer-glsl': ^2.16.1

  # Build tools
  typescript: ^5.9.3
  sass: ^1.94.2
  posthtml-extend: ^0.6.5
  posthtml-favicons: ^1.4.0
  posthtml-include: ^2.0.1
  posthtml-markdownit: ^3.1.2

  '@babel/preset-env': ^7.28.5

  '@fontsource-utils/scss': ^0.2.2
  '@fontsource-variable/arimo': ^5.2.8
  '@fontsource-variable/nunito': ^5.2.7

  # Type shims
  '@types/react-dom': ^19.2.3
  '@types/react-redux': ^7.1.34

  # Dev tools
  npm-check-updates: ^19.1.2
  prettier: ^3.6.2
  typescript-language-server: ^5.1.3
  typescript-eslint-language-service: ^5.0.5
  eslint: ^9.39.1
  '@typescript-eslint/parser': ^8.47.0
  '@typescript-eslint/eslint-plugin': ^8.47.0
  vscode-langservers-extracted: ^4.10.0

scripts:
  # Dev workflow
  build: parcel build --no-autoinstall
  serve: parcel serve --no-autoinstall
  watch: parcel watch --no-autoinstall

  # Production build
  build-dist: parcel build --no-cache --no-autoinstall

  # Checks
  check: tsc --noEmit
  style: prettier --check src
  lint: eslint --max-warnings=0 --format unix src

# Parcel config
source:
  - src/index.html
  - src/error.html

browserslist: '> 1%, not dead'

posthtml:
  plugins:
    posthtml-markdownit:
      root: src
    posthtml-extend:
      root: src
    posthtml-include:
      root: src
    # posthtml-favicons:
    #   root: src
    #   outDir: ./dist/
    #   configuration:
    #     appName: tlater.net
    #     appShortName: tlater.net
    #     appDescription: tlater's home page
    #     developerName: Tristan Daniël Maat
    #     developerURL: https://tlater.net
    #     dir: auto
    #     lang: en-US
    #     background: '#0f0f0f'
    #     theme_color: '#99d1ce'
    #     appleStatusBarStyle: black-translucent
    #     display: browser
    #     orientation: any
    #     start_url: https://tlater.net
    #     version: "1.0"
    #     icons:
    #       favicons: true
